/////////////////////////////////////////////////////////////////////////////
// rewritten by Zheng Gengbin
// deal communiaction:
// none , remap , shift
// unknown , broadcast_dim


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
extern "C" void exit(...);
#endif

#include <stdio.h>

#include "compilerApi.h"
#include "strategy.h"

#include "anls_att.h"

extern int shift_is_ok(SgStatement *s, SgSymbol *arraysymb);

// irregular.cc
extern void create_gather_tdd (SgStatement *s, int counter);
extern void assign_lhs_subscripts(SgStatement *s,int counter,int dim,SgArrayRefExp *irr_array);
extern void assign_rhs_subscripts(SgStatement *s,int counter,int dim);
extern void create_subscripts (SgStatement *s , int counter,SgArrayRefExp *irr_array=NULL);
extern void delete_lhs_subscripts (SgStatement *s , int counter);
extern void delete_rhs_subscripts (SgStatement *s , int counter);

// ghost.cc
extern void define_ishift_shadow(SgStatement *s, int counter);
extern void add_ishift_write_halo(SgStatement *s, int counter);

void add_range_copy(SgStatement *s,int counter);
void add_scatter(SgStatement * s, int counter);
void reset_array_base_for_reduced_array(SgStatement *, int , SgSymbol *);

void inc_forall_level()
{
  if (strlen(forall_level)==0) forall_level[0]='b';
  else forall_level[0]++;
  if (forall_level[0] > 'z') {
	printf("forall_level overflow.! \n");
	exit(1);
  }
}

void dec_forall_level()
{
  if (strlen(forall_level)==0) { 
	printf("forall_level underflow!.\n"); 
	exit (1);
  }
  forall_level[0]--;
  if (forall_level[0]=='a') strcpy(forall_level,"");
}

/***************************************************************************
			reset_tdd_type()
	called by ::	create_array
	Argument  ::    amount may be an array of 'shift amount'
	Functions ::  	1. if RHS have different type as LHS , reset tdd's type as RHS
***************************************************************************/
void reset_tdd_type(SgStatement *s,int counter)
{
   // get the type of lhs 
  forall_reference * lhsref=(forall_reference *)(s->childList1(0)->attributeValue(0, Forall_Ref));
  SgArrayRefExp * lhsarray = (SgArrayRefExp *) lhsref->getexpression();
  SgSymbol * lhsarraysymb=lhsref->getexpression()->symbol(); 
  SgType *ltp = lhsarraysymb->type();

   // get the type of rhs
  forall_reference * rhsref=(forall_reference *)(s->childList1(0)->attributeValue(counter, Forall_Ref));
  SgArrayRefExp * rhsarray = (SgArrayRefExp *) rhsref->getexpression();
  SgSymbol * rhsarraysymb=rhsref->getexpression()->symbol(); 
  SgType *rtp = rhsarraysymb->type();

  SgSymbol * tdd = s->getSymbolInCurrentScope(mixstring, "tdd", forall_level,counter);

  if (ltp->hasBaseType()) ltp = ltp->baseType();
  if (ltp->hasBaseType()) ltp = ltp->baseType();   // in case of T_KIND array
  if (rtp->hasBaseType()) rtp = rtp->baseType();
  if (rtp->hasBaseType()) rtp = rtp->baseType();
  if ( ltp->variant() != rtp->variant() ) {
	SgStatement *stmt = make_set_type(s, tdd, rtp);
    	s->insertStmtBefore(*stmt, *s->controlParent());
  }
}

void add_coef_for_broadcast_dim(SgStatement *s,int counter, int *amount)
{
  Forall_header_def * fhdef = (Forall_header_def *) s->getAttribute(0, FHDER_Def)->getAttributeData();
  forall_reference * fref=(forall_reference *)(s->childList1(0)->attributeValue(counter, Forall_Ref));
  SgArrayRefExp * array = (SgArrayRefExp *) fref->getexpression();
  SgSymbol * arraysymb=fref->getexpression()->symbol(); 

  forall_reference * lhsref=(forall_reference *)(s->childList1(0)->attributeValue(0, Forall_Ref));

  int dimcounter=0;
  for (int i=0; i<array->numberOfSubscripts(); i++)
  {
      SgAssignStmt *assign;
      SgSymbol * usym = s->getSymbolInCurrentScope(mixstring, "u", NULL, counter, i);
      SgVarRefExp * uexp = new SgVarRefExp(usym);
      SgSymbol * vsym = s->getSymbolInCurrentScope(mixstring, "v", NULL, counter, i);
      SgVarRefExp * vexp = new SgVarRefExp(vsym);

      int dim_parent = fref->getAmount(i);
	// set some dimension 
      if (dim_parent == -1) {
	SgExpression *one = new SgValueExp(1);
	assign = new SgAssignStmt(*uexp, *one);
    	s->insertStmtBefore(*assign, *s->controlParent());
	SgExpression *zero = new SgValueExp(0);
	assign = new SgAssignStmt(*vexp, *zero);
    	s->insertStmtBefore(*assign, *s->controlParent());
      }
      else {
	// create dim as dim_parent of dad_parent
	dimcounter ++;
      	SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "tdd", forall_level,counter);

	int index=lhsref->indexNumberOnDim(dim_parent);
	ASSERT(index!=-1);
	SgExpression *l=fhdef->getindextriple(index,0);
	ASSERT(l);
	SgExpression *u=fhdef->getindextriple(index,1);
	ASSERT(u);
	SgExpression *ss=fhdef->getindextriple(index,2);
	if (ss==NULL) ss= new SgValueExp(1);
	
        SgExpression *stride=lhsref->getstride(dim_parent,index);
	if (stride==NULL) stride=new SgValueExp(1);
        SgExpression *offset=lhsref->getoffset(dim_parent,index);
	if (offset==NULL) offset=new SgValueExp(0);

	SgExpression *amountExp = new SgValueExp(* (amount+i) );

	SgStatement *coef = make_coef(s,dad,dimcounter,l,u,ss,stride,offset,amountExp,counter,i);

    	s->insertStmtBefore(*coef, *s->controlParent());

    	collect_expression(coef, l ,0);
    	collect_expression(coef, u ,1);
    	collect_expression(coef, ss ,1);
    	collect_expression(coef, stride ,1);
    	collect_expression(coef, offset ,1);
    	analyse_expression_list(coef,coef,coef);
      }
  }
}

/***************************************************************************
				add_coef()
	called by ::
	Argument  ::    amount may be an array of 'shift amount' or NULL
			if amount=NULL, it is because in unknow mode: use runtime array pcrc_amount?.
	Functions ::  	1. generate pcrc_coefs.
***************************************************************************/
void add_coef(SgStatement * s, int counter, int * amount)
{
  Forall_header_def * fhdef = (Forall_header_def *)s->attributeValue(0, FHDER_Def);
  forall_reference * fref=(forall_reference *)s->childList1(0)->attributeValue(counter, Forall_Ref);
  SgArrayRefExp * array = (SgArrayRefExp *) fref->getexpression();
  SgSymbol * arraysymb = array->symbol(); 

     // if same array appear before , no need to create one more
  if ( fref->sameAs != -1 ) return ;

  for (int i=0; i<array->numberOfSubscripts(); i++) 
  {
    SgExpression *l, *u, *ss, *stride, *offset, *amountexp;
    SgSymbol *dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());

    int index=fref->indexNumberOnDim(i);
    if (index==-1) {
	  l = array->subscript(i);
	  u = array->subscript(i)->copyPtr();
	  ss = new SgValueExp(1);
	  stride = new SgValueExp(1);
	  offset = new SgValueExp(0);
    }
    else {
	  l = fhdef->getindextriple(index, 0);
	  if (l==NULL) l = new SgValueExp(1);
	  else l = l->copyPtr();
	  u = fhdef->getindextriple(index, 1);
	  if (u==NULL) u = new SgValueExp(1);
	  else u = u->copyPtr();
	  ss = fhdef->getindextriple(index, 2);
	  if (ss==NULL) ss = new SgValueExp(1);
	  else ss = ss->copyPtr();

	  stride=fref->getstride(i, index);
	  if (stride == NULL) stride = new SgValueExp(0);
	  offset = fref->getoffset(i, index);
	  if (offset == NULL) offset = new SgValueExp(0);
	  else offset = offset->copyPtr();
    }

    if (amount == NULL) {
  	SgSymbol *symb=s->getSymbolInCurrentScope(mixstring, "amount", NULL,counter);
	amountexp = new SgArrayRefExp(*symb);
	SgExpression *sub = new SgValueExp(i+1);
	((SgArrayRefExp *)amountexp)->addSubscript(*sub);
    }
    else
      	amountexp = new SgValueExp(* (amount+i));

    SgStatement *coef = make_coef(s,dad,i+1,l,u,ss,stride,offset,amountexp,counter,i);

    s->insertStmtBefore(*coef, *s->controlParent());

     // analyse the expressions in those exprs.
    collect_expression(coef, l ,0);
    collect_expression(coef, u ,1);
    collect_expression(coef, ss ,1);
    collect_expression(coef, stride ,1);
    collect_expression(coef, offset ,1);
    analyse_expression_list(coef, coef, coef);
  };
}

/***************************************************************************
			change_scalar_expression
 	called by ::    get_forall_expression()
	arguments ::    take an expressions as input
	FUNCTION  :: 	1. change variable with un-decided address
				to stack
			2. change do loop index to pcrc_glob() 
***************************************************************************/
void change_scalar_expression(SgStatement * s, SgExpression * oldscalar)
{
  Forall_header_def * fhdef = (Forall_header_def *) s->getAttribute(0, FHDER_Def)->getAttributeData();

  SgSymbol * scalarsym = oldscalar->symbol();  ASSERT(scalarsym);

  for (int i=0; i<fhdef->getindexnumber(); i++) {
    if(fhdef->getindexsymb(i)->id()==scalarsym->id()) {

	// if this forall index is not refered, do not change it
      SgSymbol * rng=s->getSymbolInCurrentScope(mixstring, "irg", NULL, i);

      // we need to get local index;
      SgExpression * indexexp= new SgVarRefExp(scalarsym);

      SgSymbol * indexs = s->getSymbolInCurrentScope(mixstring, "lis", scalarsym->identifier());
      SgExpression * indexsexp= new SgVarRefExp(indexs);

      indexexp = &((* indexsexp) * (* indexexp));

      SgSymbol * indexl = s->getSymbolInCurrentScope(mixstring, "lil", scalarsym->identifier());
      SgExpression * indexlexp= new SgVarRefExp(indexl);

      indexexp = &((* indexexp) + (* indexlexp));
      
      SgExpression *globFunc = make_glob(s, rng, indexexp);

      oldscalar->replace(*globFunc);
     
      break;
    }
  }
}

/***************************************************************************
			change_scalar_reference
 	called by ::    change_body()
	FUNCTION  :: 	1. change variable with un-decided address
				to stack
			2. change do loop index to pcrc_glob() 
***************************************************************************/

void change_scalar_reference(SgStatement * s, forall_reference * fref)
{
  Forall_header_def * fhdef = (Forall_header_def *) s->getAttribute(0, FHDER_Def)->getAttributeData();
  forall_reference * lhsref = (forall_reference *) s->childList1(0)->attributeValue(0, Forall_Ref);

  SgExpression * oldscalar = fref->getexpression();
  SgSymbol * scalarsym = oldscalar->symbol();

    // change pointer variable to stack
  if (isSgArrayType(scalarsym->type()) == NULL && is_pointer(scalarsym))
  {
	change_variable_by_stack(s, oldscalar);
  }

  for (int i=0; i<fhdef->getindexnumber(); i++) {
    if(fhdef->getindexsymb(i)->id()==scalarsym->id()) {
	// if this forall index is not refered, do not change it
      if ( ! lhsref->refered(i) ) continue;

      SgSymbol * rng=s->getSymbolInCurrentScope(mixstring, "irg", NULL, i);

      // we need to get local index;
      SgExpression * indexexp= new SgVarRefExp(scalarsym);

      SgSymbol * indexs = s->getSymbolInCurrentScope(mixstring, "lis", scalarsym->identifier());
      SgExpression * indexsexp= new SgVarRefExp(indexs);

      indexexp = &((* indexsexp) * (* indexexp));

      SgSymbol * indexl = s->getSymbolInCurrentScope(mixstring, "lil", scalarsym->identifier());
      SgExpression * indexlexp= new SgVarRefExp(indexl);

      indexexp = &((* indexexp) + (* indexlexp));
      
      SgExpression *globFunc = make_glob(s, rng, indexexp);

      oldscalar->replace(*globFunc);
     
      break;
    }
  }
}

/***************************************************************************
			change_array_reference
 	called by ::    change_body()
	arguments ::
			nameflag==0, remain local, else change;
			indexflag 0: use counter,  
				  1: use sdx0 
				  2: no index 
			          3: collpase, add tmp_sdx
			stackBase allow caller specify the stack base address.
			comm		nameflag  indexflag
			-------------------------------------
			IRREG : 		1 1
			NONE  : 		0 0
			SHIFT : 		0 0
			REMAP : 		1 1
			BROADCAST_SCALAR : 	1 2
			BROADCAST_DIM:          1 0
	FUNCTION  :: 	1. change the array reference in forall
***************************************************************************/
void change_array_reference(SgStatement * s, int counter, int nameflag, int indexflag, SgSymbol *stack=NULL,SgSymbol *stackBase=NULL)
{
  SgStatement * body = s->childList1(0);
  forall_reference * fref = (forall_reference *)body->attributeValue(counter,Forall_Ref);
  SgExpression * oldarray = fref->getexpression();
  SgSymbol * arraysym = oldarray->symbol();
  
  forall_reference * lhsref = (forall_reference *)body->attributeValue(0,Forall_Ref);
  SgSymbol * lhsarraysym = lhsref->getexpression()->symbol();

  SgArrayRefExp * newarray;

    // dynamic array use stack 
  if ( nameflag ==0 && is_out_of_core(arraysym) == 0 && 
      unknown_address(arraysym) )
  {
      // call index funcions to calculate stack offset
      SgSymbol * basesym = stackBase?stackBase:s->getSymbolInCurrentScope(mixstring, "tbs", forall_level,counter);
      SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysym->identifier());
      SgStatement * index_stmt = make_index(s, basesym, dad, arraysym->type());
      s->insertStmtBefore(*index_stmt, *s->controlParent());
      // change the behavior.
      nameflag = 1;
      indexflag = 1; 
  }

  if (nameflag==0) {
    SgSymbol * local= s->getSymbolInCurrentScope(arraysym->identifier());
    newarray = new SgArrayRefExp(*local);
  }
  else {
    SgSymbol * rs;
    if (stack) rs = stack;
    else {
#ifdef MEM_ALLOC
    rs= s->getSymbolInCurrentScope(stackNameOfType(arraysym->type()), "mb",NULL);
#else
    rs= s->getSymbolInCurrentScope(mixstring, stackNameOfType(arraysym->type()), NULL);
#endif
    }
    newarray = new SgArrayRefExp(*rs);
  };

  SgSymbol * indexsym;
  SgExpression *newindex=NULL;

  switch (indexflag)
  {
  case 0: {
	// zheng.gb
    	int cind = fref->sameAs;
    	if (cind == -1) cind = counter;
    	indexsym = s->getSymbolInCurrentScope(mixstring, "sdx", NULL,cind); 
    	newindex = new SgVarRefExp(indexsym);
	break;
  	}
  case 1: {
	  // in this case the pcrc_sdx0 is pcrc_sdx[max forall_def]
  	if (oldarray->numberOfAttributes(SET_INCORE) > 0 && fref->getCommunication() == REMAP)
        {
  	   indexsym = s->getSymbolInCurrentScope(mixstring, "sdx", NULL,body->numberOfAttributes(Forall_Ref)); 
	}
	else
    	   indexsym = s->getSymbolInCurrentScope(mixstring, "sdx", NULL,0); 
    	newindex = new SgVarRefExp(indexsym);
	break;
  	} 
  case 2: {
	newindex = NULL;
	break;
	}
  }

  switch (indexflag) {
  case 0: {
	if (nameflag==0)
      		newarray->addSubscript(*newindex);
    	else {
		  // must be broadcast_to_dim here?
    		int cind = fref->sameAs;
    		if (cind == -1) cind = counter;
      		SgSymbol * basesym = stackBase?stackBase:s->getSymbolInCurrentScope(mixstring, "tbs", forall_level,cind);
      		SgExpression * baseexp= new SgVarRefExp(basesym);
      		newindex = &((*baseexp)+(*newindex));
      		newarray->addSubscript(*newindex);
    	}
    	break;
  	}
  case 1: {
    	int cind = fref->sameAs;
    	if (cind == -1) cind = counter;
    	SgSymbol * basesym = stackBase?stackBase:s->getSymbolInCurrentScope(mixstring, "tbs", forall_level,cind);
    	SgExpression * baseexp= new SgVarRefExp(basesym);
    	newindex = &((*baseexp)+(*newindex));
    	newarray->addSubscript(*newindex);
    	break;
  	}
  case 2: {
    	SgSymbol * basesym = stackBase?stackBase:s->getSymbolInCurrentScope(mixstring, "tbs", forall_level,counter);
    	SgExpression * baseexp= new SgVarRefExp(basesym);
    	newarray->addSubscript(*baseexp);
    	break;
  	}
  } // end of switch

// add by zheng.gb
// delete the scalar dimension , performed on StackBase.
  if (nameflag == 1 && indexflag == 1 && !is_out_of_core(lhsarraysym))
  {
	reset_array_base_for_reduced_array(s,counter,stackBase);
  }

  // modify it
  oldarray->replace(*newarray);
}

/***************************************************************************
		reset_array_base_for_reduced_array()
	called by ::	change_array_reference()
			do_detect()
	Argument  ::    
	Functions ::  	1. modify stackBase(pcrc_tbs) , reduce the LHS scalar dimension
***************************************************************************/
// when we remap , we use the stack dad which has same data mapping as the reduced-dim LHS.
// substract the scalar dimension from stack base
void reset_array_base_for_reduced_array(SgStatement * s, int counter, SgSymbol *stackBase=NULL)
{
  Forall_header_def * fhdef = (Forall_header_def *) s->attributeValue(0, FHDER_Def);
  SgStatement * body = s->childList1(0);
  
  SgSymbol *basesym = stackBase?stackBase:s->getSymbolInCurrentScope(mixstring, "tbs", forall_level,counter);
  SgExpression *baseexp= new SgVarRefExp(basesym);
  SgExpression *newbaseexp = baseexp->copyPtr();

  // delete the reduced dimension of LHS
  forall_reference * lhsref = (forall_reference *)body->attributeValue(0, Forall_Ref);
  SgArrayRefExp * lhsarray = (SgArrayRefExp*)lhsref->getexpression();

  int done=0;
  for (int i=0; i<lhsarray->numberOfSubscripts(); i++)
  {
	if( lhsref->indexNumberOnDim(i) == -1)
	{
      		SgSymbol *indexsym = s->getSymbolInCurrentScope(mixstring, "v", NULL, 0, i);
      		SgExpression *indexexp = new SgVarRefExp(indexsym);
		newbaseexp = &((*newbaseexp) - (*indexexp));
		done=1;
	}
  }
  if (done)
  {
  SgStatement *assignStmt = new SgAssignStmt(*baseexp, *newbaseexp);
  s->insertStmtBefore(*assignStmt, *s->controlParent());
  delete assignStmt;
  }
}

/***************************************************************************
		    get_dim_collapse_offset()
	called by ::	append_index()
	Argument  ::    
	Functions ::  	1. if a dimension of an array is collapsed, calculate 
                           the offset of this dimension.
***************************************************************************/
SgExpression *get_dim_collapse_offset(SgStatement *s, int counter,int dim,int flag=0)
{
  	SgStatement * body = s->childList1(0);
  	forall_reference * fref = (forall_reference *)body->attributeValue(counter, Forall_Ref);
  	Forall_header_def * fhdef = (Forall_header_def *)s->attributeValue(0,FHDER_Def);
  	SgArrayRefExp * array = (SgArrayRefExp *) fref->getexpression();
  	SgSymbol * arraysym=fref->getexpression()->symbol();

	int indexNumber = fref->indexNumberOnDim(dim);
	if (indexNumber == -1) return NULL;
    	SgExpression *index2=NULL;
        if ((flag==1 && array_dim_collapsed(arraysym,dim)!=0) || 
	    (flag==2 && array_dim_collapsed(arraysym,dim)!=0) )
	{
/*
		if (flag == 1 && array_dim_collapsed(arraysym,dim) == -1) 
		{
		       printf("Seem cannot happen, what can I do?\n");
		       return NULL;
		}
*/
		  // calculate the first effective element in collapsed dim defined by the global index
		SgSymbol *usymb = s->getSymbolInCurrentScope(mixstring,"u",NULL,counter,dim);
		SgExpression * uexp = new SgVarRefExp(usymb);
		  // must change local to global for collapesd dimension
	  	SgSymbol * indexsym = fhdef->getindexsymb(indexNumber);
		SgExpression *strideExp = fhdef->getindextriple(indexNumber,2);
		if (strideExp == NULL) strideExp=new SgValueExp(1);
		SgExpression *lbExp = fhdef->getindextriple(indexNumber,0);
		if (lbExp == NULL) lbExp=new SgValueExp(0);
		SgExpression *dimexp = new SgVarRefExp(indexsym);
		  // create the pcrc_glob(irg,pcrc_lil) to replace the forall index;
		{
		SgSymbol * lil = s->getSymbolInCurrentScope(mixstring, "lil", indexsym->identifier());
		SgExpression *lilexp = new SgVarRefExp(lil);
		SgSymbol * irg = s->getSymbolInCurrentScope(mixstring, "irg", NULL, indexNumber);
		SgExpression *globexp = make_glob(s,irg,lilexp);
		dimexp->replace(*globexp);
		}
		dimexp = &( (*dimexp - *lbExp)/ *strideExp );  // the No of this global index relative to array section
		index2 = &( *uexp * *dimexp );
	}
	return index2;
}


/***************************************************************************
		    	append_index()
	called by ::	
	Argument  ::    flag:   0:
				1: the index of collapsed dim will be treated as expression of global index
				2: unknow mode
	Functions ::  	1. 
			2. two strategies, method =1 or 2
			3. method 2: u * i + v
			4. method 1: better way, break multiply into additon
***************************************************************************/
void append_index(SgStatement *s, int counter,int flag=0)
{
  int i;
  SgStatement * body = s->childList1(0);
  Forall_header_def * fhdef = (Forall_header_def *)s->attributeValue(0,FHDER_Def);

  forall_reference * fref = (forall_reference *)body->attributeValue(counter, Forall_Ref);
  SgArrayRefExp * array = (SgArrayRefExp *) fref->getexpression();
  SgSymbol * arraysym=fref->getexpression()->symbol();

  forall_reference * lhsref = (forall_reference *)body->attributeValue(0, Forall_Ref);
  SgSymbol  * lhsarraysymb = lhsref->getexpression()->symbol();

// zheng.gb
  if ( fref->sameAs != -1 ) return;

// unknown mode ; we introduce pcrc_comm to hold the communication type.
  SgSymbol *commsymb=NULL;
  SgExpression *conExp=NULL;
  if (flag==2)
  {
	commsymb=s->getSymbolInCurrentScope(mixstring, "comm", NULL,counter);
	SgExpression *commExp = new SgVarRefExp(commsymb);
  	conExp = &( SgNeqOp(*commExp,*new SgValueExp(2)));	// Not REMAP
  }

  SgExpression * firstexp=NULL;

    // this is the index name, normally: pcrc_sdx[counter]
  SgSymbol * index_sdx_sym = s->getSymbolInCurrentScope(mixstring, "sdx", NULL,counter); 

    // decide which strategy to use
  int method = 0x2 ;
  if (opt_strategy & INDEX_OPTIMIZE) method = 0x1;
    // as to OUT_OF_CORE case, we use the simple way to create index
  if (is_out_of_core(arraysym)) method = 0x2;
    //  optimize for out_of_core
  if (array->numberOfAttributes(SET_INCORE) > 0)
  {
    if (fref->getCommunication() == BROADCAST_DIM)
	method = 0x1;         // use own sdx
    else
    if (counter == 0) {
         // the sdx0 is renamed as sdx[max forall_def]
	method |= 0x1;
  	index_sdx_sym = s->getSymbolInCurrentScope(mixstring, "sdx", NULL,body->numberOfAttributes(Forall_Ref)); 
    }
  }

////////////////////////////   METHOD == 1  //////////////////////////////////
// this is an optimized strategy
// calculate init_stmt, push_stmt, add_stmt
//  the places of these statements are:
//  init_stmt j
//  do j
//  push_stmt j
//  do i
//  enddo i
//  add_stmt j
//  enddo j
if ( method & 0x1)
{
  SgExpression * init_index = NULL;
  SgExpression * add_index = NULL;
  SgExpression *index_tmp_sdx_exp;
  SgStatement *init_stmt = NULL;
  SgSymbol *indextmpsym;

  SgExpression * index_sdx_exp = new SgVarRefExp(index_sdx_sym);

  // this loop is to deal with scalar index, such as forall(i) a(j) = 1
  //  for unused index in array , create two statement to hold the old value	zheng.gb 1997/12/10
  int   dimcounter=0;
  for (int j=0; j<fhdef->getindexnumber(); j++) 
  {
	int scalar_dim=1;
  	for (i = 0; i<array->numberOfSubscripts(); i++) 
      		if (fref->getIndex(i,j)!=0) scalar_dim=0;
        dimcounter++;
	// if not scalar , leave to next step
	if ( scalar_dim == 0) continue;
	// donot add in the innest level
	if (j==0) continue;
  	indextmpsym = s->getSymbolInCurrentScope(mixstring, "tmp","sdx", counter,dimcounter-1); 
  	index_tmp_sdx_exp = new SgVarRefExp(indextmpsym);

	  // these statements are inserted later in add_do_loop()
	SgAssignStmt *push_stmt = new SgAssignStmt( *index_tmp_sdx_exp , *index_sdx_exp);
	body->addAttribute(INDEX_OPT+j, push_stmt , sizeof(push_stmt) );

  	SgAssignStmt *add_stmt = new SgAssignStmt( *index_sdx_exp , *index_tmp_sdx_exp );
	body->addAttribute(INDEX_ADD+j, add_stmt , sizeof(add_stmt) );
  }

  for (i = 0; i<array->numberOfSubscripts(); i++) 
  {
    dimcounter=0;

      // create init_index just by i once.
    if (counter == 0 && array->numberOfAttributes(SET_INCORE) > 0 &&
	fref->indexNumberOnDim(i) == -1) 
    ;
    else {
    	SgSymbol * vsymb = s->getSymbolInCurrentScope(mixstring, "v", NULL, counter, i);
    	SgExpression *index1 = new SgVarRefExp(vsymb);
    	init_index = init_index + *index1;
    }

    for (int j=0; j<fhdef->getindexnumber(); j++) 
    {
      int l;
      dimcounter++;
      if (fref->getIndex(i,j)!=0) 
      {
	int add = 1;
	// must allow permutation and duplicate		zheng.gb
  	for (l = 0; l < i; l++) {
      	   if (fref->getIndex(l,j)!=0) 
		{ add=0; printf("scalar dim.  Cannot handle!\n"); break;}
	}
	if (add==0) continue;

	if (j != 0 ) {
  		indextmpsym = s->getSymbolInCurrentScope(mixstring, "tmp","sdx",counter,dimcounter-1); 
  		index_tmp_sdx_exp = new SgVarRefExp(indextmpsym);

		SgStatement *push_stmt = new SgAssignStmt( *index_tmp_sdx_exp , *index_sdx_exp);
		// runtime communication detection condition
  		if (flag == 2) {
  			push_stmt = new SgLogIfStmt(*conExp, *push_stmt);
  		}
		body->addAttribute(INDEX_OPT+j, push_stmt , sizeof(push_stmt) );
	}

        add_index = NULL;
  	for (l = 0; l<array->numberOfSubscripts(); l++) 
	{
      	   if (fref->getIndex(l,j)!=0) 
	   {
		SgSymbol * usymb = s->getSymbolInCurrentScope(mixstring, "u", NULL, counter, l);
		SgExpression * uexp = new SgVarRefExp(usymb);
		add_index = add_index + *uexp;
	   }
	}

	if ( j != 0 )
  		add_index = index_tmp_sdx_exp + (*add_index);
	else
  		add_index = index_sdx_exp + (*add_index);

  	SgStatement *add_stmt = new SgAssignStmt(*index_sdx_exp->copyPtr(), *add_index);
	// runtime communication detection condition
  	if (flag == 2) {
  		add_stmt = new SgLogIfStmt(*conExp, *add_stmt);
  	}
	body->addAttribute(INDEX_ADD+j, add_stmt , sizeof(add_stmt) );
      }	// end of if
    }; // end for j
  }     // end for i

  // if communication is NONE , and this dimension is collapsed, we donot 
  // create these statements.
  // flag=1 , means we can decide in compiling time that a dim is collapsed
  // flag=2 , means we cannot, we have to decide in runtime
  SgStatement *first_stmt;
  if (flag==2) {
  	first_stmt = new SgAssignStmt( *index_sdx_exp , *init_index );
  	init_stmt = new SgIfStmt(*conExp, *first_stmt);
  }
  if ( flag == 1 || flag == 2)  
    for (i = 0; i<array->numberOfSubscripts(); i++) 
    {
	// if the lhs is collapsed in corresponent dimension, no need to add get offset.
        int rindex = fref->indexNumberOnDim(i);
        if (rindex != -1) {
	   int lindex = lhsref->dimNumberOnIndex(rindex);
	   if (lindex != -1) {
           if (array_dim_collapsed(lhsref->getexpression()->symbol(), lindex) == 1)
		continue;
	   }
	}
	  // index2 hold the offset of this collapsed dimension.
	SgExpression *index2 = get_dim_collapse_offset(s,counter,i,flag);
	if (index2 == NULL) continue;
        if (flag == 1)
	{
    		init_index = init_index + *index2;
	}
	  // create if statement that have a possible branches: index2
  	if (flag == 2) 
	{
		index2 = &(*index_sdx_exp + *index2);
  		SgStatement *stmt = new SgAssignStmt( *index_sdx_exp->copyPtr(), *index2);
		if (array_dim_collapsed(arraysym,i) == -1)
		{
      		   SgSymbol *dad = s->getSymbolInCurrentScope(mixstring,"dad",arraysym->identifier());
		   SgExpression *getDistcode = make_distcode(s,dad,i+1);
		   SgExpression *collapsed = & (SgEqOp(*getDistcode,*new SgValueExp(0)));
 		   stmt = new SgLogIfStmt(*collapsed, *stmt);
		}
		first_stmt->insertStmtAfter(*stmt,*first_stmt->controlParent());
	}
    }  // end of for
  if (flag != 2) 
   	init_stmt = new SgAssignStmt( *index_sdx_exp , *init_index );
  body->addAttribute(INDEX_INIT, init_stmt , sizeof(init_stmt) );
}

////////////////////////////   METHOD == 2  //////////////////////////////////

index_sdx_sym = s->getSymbolInCurrentScope(mixstring, "sdx", NULL,counter); 

if (method & 0x2){ 			// NOT INDEX_OPTIMIZE
  SgExpression *init_index = NULL;
  SgStatement *first_stmt = NULL,*init_stmt = NULL;
  SgSymbol *indextmpsym = s->getSymbolInCurrentScope(mixstring, "tmp","sdx",counter); 
  SgExpression *index_tmp_sdx_exp = new SgVarRefExp(indextmpsym);
  if ( flag == 1 || flag == 2)  
  {
    int decided = flag == 1? 1:0;
      // this time is equal to unknown mode
    if (flag == 1 && array_all_collapsed(arraysym) == -1)
    {
	ASSERT(conExp == NULL);
	decided = 0;
	conExp = new SgBoolValueExp(1);
    }

    for (i = 0; i<array->numberOfSubscripts(); i++) 
    {
	  // index2 hold the offset of this collapsed dimension.
	SgExpression *index2 = get_dim_collapse_offset(s,counter,i,flag);
	if (index2 == NULL) continue;
        if ( decided == 1 )
	{
    		init_index = init_index + *index2;
	}
  	else  // if (flag == 2) 
	{
	          // create if statement that have a possible branches: index2
		if (first_stmt != NULL)
		    index2 = &(*index_tmp_sdx_exp + *index2);
  		SgStatement *stmt = new SgAssignStmt( *index_tmp_sdx_exp->copyPtr(), *index2);
		if (array_dim_collapsed(arraysym,i) == -1)
		{
      		  SgSymbol *dad = s->getSymbolInCurrentScope(mixstring,"dad",fref->getexpression()->symbol()->identifier());
		  SgExpression *getDistcode = make_distcode(s,dad,i+1);
		  SgExpression *collapsed = & (SgEqOp(*getDistcode,*new SgValueExp(0)));
  		  SgStatement *zero = new SgAssignStmt( *index_tmp_sdx_exp->copyPtr(), *new SgValueExp(0));
  		  stmt = new SgIfStmt(*collapsed, *stmt, *zero);
		}
		if (first_stmt == NULL) {
  			init_stmt = new SgIfStmt(*conExp, *stmt);
			first_stmt = stmt;
		}
		else
		first_stmt->insertStmtAfter(*stmt,*first_stmt->controlParent());
	}
    }  // end of for
  } // end of if
  if (init_index && flag == 1) {
   	init_stmt = new SgAssignStmt( *index_tmp_sdx_exp , *init_index );
  }
  if (init_stmt)
  	body->addAttribute(INDEX_INIT, init_stmt , sizeof(init_stmt) );

  SgExpression * rhs=NULL;
  for (i = 0; i<array->numberOfSubscripts(); i++) 
  {
      // if the lhs is out of core , the oc_write will use pcrc_sdd0, which 
      // already contain the scalar offset, so sdx0 donot count them.
    if (is_out_of_core(lhsarraysymb) && counter == 0 && lhsref->indexNumberOnDim(i) == -1) 
	;
    else {
      SgSymbol * vsymb = s->getSymbolInCurrentScope(mixstring,"v",NULL,counter, i);
      firstexp = new SgVarRefExp(vsymb);
      rhs = rhs + *firstexp;
    }
    for (int j=0; j<fhdef->getindexnumber(); j++) {
      if (fref->getIndex(i,j)!=0) {

	SgExpression * indexexp = new SgVarRefExp (fhdef->getindexsymb(j));

	SgSymbol * usymb = s->getSymbolInCurrentScope(mixstring,"u",NULL,counter, i);
	SgExpression * uexp = new SgVarRefExp(usymb);

	uexp=&((*uexp)*(*indexexp));

	rhs = rhs + (*uexp);

      }
    };
  }    
  if (flag==1 || flag==2)
     if (init_stmt)
	rhs = rhs + (*index_tmp_sdx_exp);

  ASSERT(rhs != NULL);
  SgExpression * index_sdx_exp = new SgVarRefExp(index_sdx_sym);

  SgStatement * stmt = new SgAssignStmt(*index_sdx_exp, *rhs);
  if (flag == 2)
	stmt = new SgLogIfStmt(*conExp, *stmt);

    // insert after the forall body;
    // but OUT_OF_CORE donot insert, we will modify the expression later in foralloc.cc
  if (is_out_of_core(arraysym) > 0) {
  	body->addAttribute(INDEX_SDX, stmt , sizeof(stmt) );
  }
  else
  	body->insertStmtAfter(*stmt, *s);

} // end of !INDEX_OPTIMIZE

}

/***************************************************************************
				create_array()
	called by ::
	Argument  ::    flag == 0 : create array according to LHS
	Functions ::  	1. create array DAD 'tdd?' / delete array
			2. allocate memory / deallocate
***************************************************************************/
void create_array (SgStatement *s, int flag, int counter)
{
  int i;
  SgStatement * body = s->childList1(0);

  Forall_header_def * fhdef = (Forall_header_def *) s->attributeValue(0, FHDER_Def);

  forall_reference * lhsref = (forall_reference *)body->attributeValue(0, Forall_Ref);
  SgArrayRefExp * lhsarray = (SgArrayRefExp *) lhsref->getexpression();
  SgSymbol * lhsarraysymb  = lhsarray->symbol();

  forall_reference * rhsref = (forall_reference *)body->attributeValue(counter, Forall_Ref);
  SgArrayRefExp * rhsarray = (SgArrayRefExp *) rhsref->getexpression();
  SgSymbol * rhsarraysymb  = rhsarray->symbol();

  int storage = getArrayStorage(rhsarraysymb);

  forall_reference * fref;
  if(flag==0)
    fref = (forall_reference *)body->attributeValue(0, Forall_Ref);
  else
    fref = (forall_reference *)body->attributeValue(counter, Forall_Ref);

  SgArrayRefExp * array = (SgArrayRefExp *) fref->getexpression();
  SgSymbol * arraysymb  = fref->getexpression()->symbol();

  SgSymbol * tddsymb=s->getSymbolInCurrentScope(mixstring, "tdd", forall_level,counter);

  if (fref->getCommunication() == BROADCAST_SCALAR || 
      fref->getCommunication() == BROADCAST_DIM)
  {
      int elementary_assign=0;
         // optimization
      if (opt_strategy & OTHER_OPTIMIZE)
      {
	// as to broadcast_scalar, we can reduce the group of the pcrc_tdd1 
	// so that remap can take less time
	for (i=0; i<fhdef->getindexnumber(); i++)
        {
		SgExpression *l=fhdef->getindextriple(i,0);
		SgExpression *u=fhdef->getindextriple(i,1);
		if ( *l != *u ) break;
        }
	if (i==fhdef->getindexnumber()) 
	{ 
		if (!silentFlag)
		printf("optimize:Elemental assignment.\n"); 
		elementary_assign=1; 
	}
      }

      int rank = fref->numberOfIndex();
   
      SgSymbol *grp,*tmpdad;
      SgExpression * grpExp;
      if(fref->getCommunication() == BROADCAST_DIM)
      {
	// specify group as Lhs
	Alignment_def * ladef = (Alignment_def *)lhsarraysymb->attributeValue(0, Align_Def);
	if (ladef)
	{
	   Distribute_def * ddef = (Distribute_def *)ladef->gettosymbol()->attributeValue(0, Dist_Def);
    	   grp = s->getSymbolInCurrentScope(mixstring, "grp", ddef->gettosymbol()->identifier()); 
	}
        else {	// if lhs is irregular , the array is collapsed by default.
    	   grp = s->getSymbolInCurrentScope(mixstring, "grp_glob", NULL); 
	}
        grpExp = new SgVarRefExp(grp);
      }
      else	// specify global grp
      {
	  // optimize , reduce the group of DAD
        if (fref->getCommunication() == BROADCAST_SCALAR && elementary_assign==1) 
	{
if (!silentFlag)
printf("Optimize: reduce processor group of array:%s.\n",lhsarraysymb->identifier());
    	  tmpdad=s->getSymbolInCurrentScope(mixstring, "sdd", "tmp",counter);
          SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", lhsarraysymb->identifier());
	  SgStatement *section_stmt=make_new_array_section(s,tmpdad,0,dad);
          s->insertStmtBefore(*section_stmt, *s->controlParent());
	  for (i=0; i<lhsarray->numberOfSubscripts(); i++)
          {
		int index = lhsref->indexNumberOnDim(i);
		SgExpression *offset = lhsref->getoffset(index,i);
		SgExpression *stride = lhsref->getstride(index,i);
		SgExpression *u = fhdef->getindextriple(index,1);
		SgExpression *expr = calculateExp(&(*stride * *u + *offset));
		SgStatement *scalar_stmt;
		scalar_stmt = make_set_array_scalar(s,tmpdad,expr,dad,i+1);
      		s->insertStmtBefore(*scalar_stmt, *s->controlParent());
		analyse_expression(s, expr);
	  }
	  grpExp = make_group(s, tmpdad);
        }
	else
        {
    	  grp = s->getSymbolInCurrentScope(mixstring, "grp_glob", NULL); 
          grpExp = new SgVarRefExp(grp);
        }
      }

      SgStatement *assign = make_new_array_data(s, tddsymb, arraysymb->type(), 
						storage, rank,grpExp);

      s->insertStmtBefore(*assign, *s->controlParent());

      if(fref->getCommunication() == BROADCAST_DIM)
	add_range_copy(s,counter);
//	add_align(s,counter);

// optimize
      if (fref->getCommunication() == BROADCAST_SCALAR && elementary_assign==1) 
      {
	SgStatement *delete_stmt = make_delete_array(s,tmpdad);
    	s->insertStmtBefore(*delete_stmt, *s->controlParent());
      }
  }
  else 	// else if BROADCAST_SCALAR || BROADCAST_DIM
  {

    // pcrc_new_array_section
  {
    int dim = fhdef->getindexnumber();
    SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
    SgStatement* assign = make_new_array_section(s, tddsymb, dim , dad);
    s->insertStmtBefore(*assign, *s->controlParent());
  }

    // set tdd as IN_CORE
  {
      // when create tdd as LHS in out of core case, 
    int set_incore = 0;
    if (flag == 0 && 
       (rhsref->getCommunication()==REMAP || rhsref->getCommunication() == UNKNOW)) 
    {
       if (is_out_of_core(lhsarraysymb) && !is_out_of_core(rhsarraysymb) )
	   set_incore = 1;
    }
    if (set_incore == 0) 
    {
	// try to consider one dimension array as in_core
       if (rhsarray->numberOfAttributes(SET_INCORE) > 0)
	   set_incore = 1;
    }
    if (set_incore == 1)
    {
if (!silentFlag)
printf("HERE SET_IC\n");
	  SgStatement * stmt = make_set_ic(s,tddsymb);
    	  s->insertStmtBefore(*stmt, *s->controlParent());
    }
  }

  int dimcounter = 0;

    // set_array_triplet or set_array_scalar
  for (i=0; i<array->numberOfSubscripts(); i++) {
    int index = fref->indexNumberOnDim(i);

    if (index!=-1) {
        // set_array_triplet
      dimcounter++;

      // the following subprogram add start, end, stride;
      SgExpression *start, *end, *stride;
      {
	start = fref->getoffset(i,index);
	start = start+((*fref->getstride(i,index))*(*fhdef->getindextriple(index,0)));
	analyse_expression(s, start);

	end = fref->getoffset(i,index);
	end = end+((*fref->getstride(i,index))*(*fhdef->getindextriple(index,1)));
	analyse_expression(s, end);

	if (fhdef->getindextriple(index, 2)!=NULL) 
	  stride = &(*fref->getstride(i,index))*(*fhdef->getindextriple(index,2));
	else 
	  stride = fref->getstride(i,index);
	analyse_expression(s, stride);
      }

      SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());

      SgStatement *funcall = make_set_array_triplet(s,tddsymb,dimcounter,start,
							end,stride,dad,i+1);
      s->insertStmtBefore(*funcall, *s->controlParent());
    }
    else {
	// set_array_scalar
      SgExpression * scalar = ( (SgArrayRefExp *) fref->getexpression() ) ->subscript(i);
      SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
      SgStatement *funcall = make_set_array_scalar(s,tddsymb,scalar,dad,i+1);
      s->insertStmtBefore(*funcall, *s->controlParent());
    }
  }
  } // end of if BROADCAST_SCALAR

    // allocate memory according to RHS symbol's type, even if create tdd as LHS (flag==0)
  SgSymbol * mHandle;
  {
  SgSymbol * base = s->getSymbolInCurrentScope(mixstring, "tbs", forall_level, counter);

#ifdef MEM_ALLOC
  mHandle = s->getSymbolInCurrentScope(mixstring, "mh", forall_level, counter);
  SgStatement *alloc=make_stack_alloc(s,rhsarraysymb->type(),base,tddsymb,mHandle);
#else
  SgStatement *alloc=make_alloc(s,rhsarraysymb->type(),base,tddsymb);
#endif

  s->insertStmtBefore(*alloc, *s->controlParent());
  }

    // set type as RHS
  {
  if (flag == 0) 
       reset_tdd_type(s,counter);
  }

    // reset base;
  {
  SgSymbol * basesym = s->getSymbolInCurrentScope(mixstring, "tbs", forall_level,counter);

  SgStatement *funcall=make_reset_array_base(s,tddsymb,rhsarraysymb->type(),basesym, mHandle);

  s->insertStmtBefore(*funcall, *s->controlParent());
  }

    // call delete_array;
  {
  SgStatement *delete_stmt = make_delete_array(s,tddsymb);
  s->insertStmtAfter(*delete_stmt, *s->controlParent());
  }

    // call real free;
  {
#ifdef MEM_ALLOC
  SgSymbol * base = s->getSymbolInCurrentScope(mixstring, "mh", forall_level, counter);
#else
  SgSymbol * base = s->getSymbolInCurrentScope(mixstring, "tbs", forall_level, counter);
#endif
  SgStatement* free_stmt = make_free(s,rhsarraysymb->type(),base);
  s->insertStmtAfter(*free_stmt, *s->controlParent());
  }
}

/***************************************************************************
			create_ishift_array()
	called by ::    do_i_write_halo
	Functions ::  	create array for immediate-shift communication
			1. create array DAD 'tdd?' / delete array
***************************************************************************/
void create_ishift_array (SgStatement *s, int counter)
{
  int i;
  SgStatement * body = s->childList1(0);

  Forall_header_def * fhdef = (Forall_header_def *)s->attributeValue(0,FHDER_Def);
  forall_reference * fref = (forall_reference *)body->attributeValue(counter, Forall_Ref);

  SgArrayRefExp * array = (SgArrayRefExp *) fref->getexpression();
  SgSymbol * arraysymb  = fref->getexpression()->symbol();

  SgSymbol * tddsymb=s->getSymbolInCurrentScope(mixstring, "tdd", forall_level,counter);
  SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());

  // pcrc_new_array_section()
  {
    int dim = fref->numberOfDiffIndex();
    SgStatement* assign = make_new_array_section(s, tddsymb, dim , dad);
    s->insertStmtBefore(*assign, *s->controlParent());
  }

  int dimcounter = 0;

  for (i=0; i<array->numberOfSubscripts(); i++) {
    int index = fref->indexNumberOnDim(i);

    if (index!=-1) {
/*
	// pcrc_set_array_copy()
      SgStatement *array_copy = make_set_array_copy(s,tddsymb,dimcounter,
							dad,i+1);
      s->insertStmtBefore(*array_copy, *s->controlParent());
*/
	// pcrc_set_array_triplet()
      dimcounter++;

      SgExpression *start = get_lbound(arraysymb, i);
      analyse_expression(s, start);
      SgExpression *end  = get_ubound(arraysymb, i);
      analyse_expression(s, end);
      SgExpression *stride = new SgValueExp(1);

      SgStatement *funcall = make_set_array_triplet(s, tddsymb, dimcounter,
				start,end,stride,dad,i+1);
      s->insertStmtBefore(*funcall, *s->controlParent());
    }
    else {
	// pcrc_set_array_scalar()
      SgExpression * scalar = ( (SgArrayRefExp *) fref->getexpression() ) ->subscript(i);
      SgStatement *funcall = make_set_array_scalar(s,tddsymb,scalar,dad,i+1);
      s->insertStmtBefore(*funcall, *s->controlParent());
      analyse_expression(s, scalar);
    }
  } // end of for
}


void delete_section(SgStatement *s, int counter)
{
  SgSymbol * symb =s->getSymbolInCurrentScope(mixstring, "sdd", forall_level, counter);
  SgStatement *funcall = make_delete_array(s,symb);
  s->insertStmtAfter(*funcall, *s->controlParent());
}

// process: broadcast to dimension
// create copy of the range from the LHS
// and set outofcore if needed
void add_range_copy(SgStatement *s,int counter)
{
  int i;
  SgStatement * body = s->childList1(0);

  Forall_header_def * fhdef = (Forall_header_def *) s->attributeValue(0, FHDER_Def);

  forall_reference * fref= (forall_reference *) body->attributeValue(counter, Forall_Ref);
  SgArrayRefExp * array = (SgArrayRefExp *) fref->getexpression();
  SgSymbol * arraysymb  = array->symbol();

  forall_reference * lhsref= (forall_reference *) body->attributeValue(0, Forall_Ref);
  SgArrayRefExp * lhsarray = (SgArrayRefExp *) lhsref->getexpression();
  SgSymbol * lhsarraysymb  = lhsarray->symbol();

    // storage must be same as LHS  ???
  int storage = getArrayStorage(arraysymb);

  SgSymbol * dad_parent = s->getSymbolInCurrentScope(mixstring, "sdd", NULL,0);

  int dimcounter;
  if (storage == COLUMN_MAJOR) 
  {
    dimcounter=0;
    for(i=0; i<MAX_ALIGN_DIM;i++)
    {
	// dim is the correspondent dimension of lhs
        int dim=fref->getAmount(i);
	if (dim==-1) continue;
	dimcounter++;

	// pcrc_set_array_copy
        SgSymbol * dad=s->getSymbolInCurrentScope(mixstring, "tdd", forall_level,counter);
	SgStatement *array_copy = make_set_array_copy(s,dad,dimcounter,dad_parent,dim+1);

        s->insertStmtBefore(*array_copy, *s->controlParent());
    }
  }
  else
  {
    dimcounter = 1;
    for (i=0; i< MAX_ALIGN_DIM; i++) 
	if (fref->getAmount(i) != -1) dimcounter++;
    for(i=MAX_ALIGN_DIM; i>=0; i--)
    {
	// dim is the correspondent dimension of lhs
        int dim=fref->getAmount(i);
	if (dim==-1) {
	  continue;
	}
	dimcounter--;

	// pcrc_set_array_copy
        SgSymbol * dad=s->getSymbolInCurrentScope(mixstring, "tdd", forall_level,counter);
	SgStatement *array_copy = make_set_array_copy(s,dad,dimcounter,dad_parent,dim+1);

        s->insertStmtBefore(*array_copy, *s->controlParent());
    }
  }

    // as if lsh is in_core
  if (array->numberOfAttributes(SET_INCORE) > 0);
  else
  if (is_out_of_core(lhsarraysymb))
  {
        SgSymbol * dad=s->getSymbolInCurrentScope(mixstring, "tdd", forall_level,counter);
        SgStatement * ts=make_oc_init(s,dad,IN_CORE_SIZE);
        s->insertStmtBefore(*ts, *s->controlParent());
  }
}

// create section, but need not allocate memmory;
// sdd[?]
void create_section(SgStatement *s, int counter)
{
  SgStatement * body;
  body = s->childList1(0);

  Forall_header_def *fhdef = (Forall_header_def *)s->attributeValue(0, FHDER_Def);

  forall_reference *fref = (forall_reference *)body->attributeValue(counter, Forall_Ref);
  SgArrayRefExp * array = (SgArrayRefExp *) fref->getexpression();  
  SgSymbol * arraysymb  = array->symbol();

  SgSymbol * sddsymb=s->getSymbolInCurrentScope(mixstring, "sdd", forall_level, counter);
  // pcrc_new_array_section
  {
    int dim;
    if (fref->getCommunication() == BROADCAST_SCALAR )
    	dim = 0;
    else
    	dim = fref->numberOfIndex();

    SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
    SgStatement *assign = make_new_array_section(s, sddsymb, dim , dad);
    s->insertStmtBefore(*assign, *s->controlParent());
  }

  int dimcounter = 0;
  for (int i=0; i<array->numberOfSubscripts(); i++) {
    int index = fref->indexNumberOnDim(i);

    if (index != -1) 
    {	// pcrc_set_array_triplet
      dimcounter++;

      // the following subprogram add start, end, stride;
      SgExpression *start;
      start=fref->getoffset(i,index);
      if (start) start = start->copyPtr();	
      start=start+((*fref->getstride(i,index)->copyPtr())*(*fhdef->getindextriple(index,0)->copyPtr()));
      analyse_expression(s, start);

      SgExpression *end;
      end=fref->getoffset(i,index);
      if (end) end = end->copyPtr();	
      end=end+((*fref->getstride(i,index)->copyPtr())*(*fhdef->getindextriple(index,1)->copyPtr()));
      analyse_expression(s, end);

      SgExpression *stride;
      stride = fhdef->getindextriple(index, 2);
      stride = stride * (*fref->getstride(i,index));
      stride = calculateExp(stride);

      SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());	

      SgStatement *funcall = make_set_array_triplet(s,sddsymb,dimcounter,
						start,end,stride,dad,i+1);
      s->insertStmtBefore(*funcall, *s->controlParent());
    }
    else {
	// pcrc_set_array_scalar
      SgExpression * scalar = array->subscript(i);
      SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
      SgStatement *funcall = make_set_array_scalar(s,sddsymb,scalar,dad,i+1);
      s->insertStmtBefore(*funcall, *s->controlParent());
    }
  }
  
    // counterpart
  delete_section(s, counter);
}

//---------------

// create pcrc_remap
void add_remap(SgStatement * s, int counter)
{
// add by Zheng Gengbin
// decide if we must transpose the remap
  int remap=0;
  int dd[7];
  int dno=0;
  int i;
  SgStatement * body = s->childList1(0);
  forall_reference * lhsref = (forall_reference *) body->attributeValue(0, Forall_Ref);
  forall_reference * rhsref = (forall_reference *) body->attributeValue(counter, Forall_Ref);
  for (i=0; i<7 ; i++)
  {
	dd[i]=-1;
	if (rhsref->getAmount(i)!=-1)
	{
		dno++;
		int nodim=0;
		int amount=rhsref->getAmount(i);
		// delete the no scalar dim
		for (int k=0; k<amount; k++)
			if (lhsref->indexNumberOnDim(k)==-1) nodim++;
		dd[dno-1]=amount-nodim;
	}
  }
  dd[dno]=-1;
  i=0;
  while (i<dno-1 && dd[i]<dd[i+1]) i++;
  if (i==dno-1 || dno==0) { dd[0]=-1; dno =0 ; remap=1;}
    // if BROADCAST_DIM , set_array_align insure the mapping.
  if (rhsref->getCommunication()==BROADCAST_DIM) remap=1;

  SgSymbol * symb=s->getSymbolInCurrentScope(mixstring, remap?"remap":"remap_transpose", NULL);
  SgCallStmt * funcall= new SgCallStmt(*symb);

  SgSymbol *dadsec = s->getSymbolInCurrentScope(mixstring, "tdd", forall_level, counter);
  SgExpression * dadexp = new SgVarRefExp(dadsec);
  funcall->addArg(*dadexp);
  delete dadexp;

  SgSymbol *dadsrc = s->getSymbolInCurrentScope(mixstring, "sdd", forall_level , counter);
  SgExpression * dadsecexp = new SgVarRefExp(dadsrc);
  funcall->addArg(*dadsecexp);
  delete dadsecexp;

  if (remap==0)
    for (i=0;i<=dno; i++)
    {
	SgExpression *dexp = new SgValueExp(dd[i]);
  	funcall->addArg(*dexp);
	delete dexp;
    }

  s->insertStmtBefore(*funcall, *s->controlParent());
}

//---------------

// create pcrc_gather()
void add_gather(SgStatement * s, int counter)
{
  SgStatement * body = s->childList1(0);
  forall_reference * lhsref = (forall_reference *) body->attributeValue(0, Forall_Ref);
  forall_reference * rhsref = (forall_reference *) body->attributeValue(counter, Forall_Ref);

  SgSymbol * symb=s->getSymbolInCurrentScope(mixstring, "gather", NULL);
  SgCallStmt * funcall= new SgCallStmt(*symb);

  symb=s->getSymbolInCurrentScope(mixstring, "tdd", forall_level, counter);
  SgVarRefExp * dadexp = new SgVarRefExp(symb);
  funcall->addArg(*dadexp);
  delete dadexp;

//  use dad directly
//  symb=s->getSymbolInCurrentScope(mixstring, "sdd", NULL , counter);
  symb=s->getSymbolInCurrentScope(mixstring, "dad", rhsref->getexpression()->symbol()->identifier() );
  SgVarRefExp * dadsecexp = new SgVarRefExp(symb);
  funcall->addArg(*dadsecexp);
  delete dadsecexp;

  SgArrayRefExp *exp = isSgArrayRefExp(rhsref->getexpression());
  if (exp) 
  	for (int i=0; i< exp->numberOfSubscripts(); i++)
	{
  		symb=s->getSymbolInCurrentScope(mixstring, "subs", forall_level , counter,i);
  		SgVarRefExp * dadsecexp = new SgVarRefExp(symb);
  		funcall->addArg(*dadsecexp);
  		delete dadsecexp;
	}

  s->insertStmtBefore(*funcall, *s->controlParent());
}

//-------------------

// add pcrc_scatter()
void add_scatter(SgStatement * s, int counter)
{
  SgStatement * body = s->childList1(0);
  forall_reference * lhsref = (forall_reference *) body->attributeValue(0, Forall_Ref);
  SgExpression *array = lhsref->getexpression();

  SgSymbol * symb=s->getSymbolInCurrentScope(mixstring, "scatter", NULL);
  SgCallStmt * funcall= new SgCallStmt(*symb);

    // this is the array we have calculate the value in it.
  symb=s->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);
  SgVarRefExp * dadexp = new SgVarRefExp(symb);
  funcall->addArg(*dadexp);
  delete dadexp;

  SgArrayRefExp *irr_array = (SgArrayRefExp *)array->attributeValue(0,IRREG_ARRAY);
  ASSERT(irr_array);

    // use original irregular array name.
  symb=s->getSymbolInCurrentScope(mixstring,"dad",irr_array->symbol()->identifier() );
  SgVarRefExp * dadsecexp = new SgVarRefExp(symb);
  funcall->addArg(*dadsecexp);
  delete dadsecexp;

    // add subscript arrays according to the original irregular array's dimension.
  for (int i=0; i< irr_array->numberOfSubscripts(); i++)
  {
  	symb=s->getSymbolInCurrentScope(mixstring, "subs", forall_level , counter,i);
  	SgVarRefExp * dadsecexp = new SgVarRefExp(symb);
  	funcall->addArg(*dadsecexp);
  	delete dadsecexp;
  }

  s->insertStmtAfter(*funcall, *s->controlParent());
}

void add_shift(SgStatement * s, int counter, int dim, int amount)
{
  SgSymbol * symb;
  
  symb=s->getSymbolInCurrentScope(mixstring, "tshift", NULL);
  
  SgCallStmt * funcall= new SgCallStmt(*symb);

  symb=s->getSymbolInCurrentScope(mixstring, "real_stack", NULL);

  SgArrayRefExp * stackexp = new SgArrayRefExp(*symb);

  SgSymbol * base =s->getSymbolInCurrentScope(mixstring, "tbs", NULL, counter);
  SgExpression * baseexp = new SgVarRefExp(base);
  stackexp->addSubscript(*baseexp);
  funcall->addArg(*stackexp);

  symb=s->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);
  SgExpression * dadsecexp = new SgVarRefExp(symb);
  funcall->addArg(*dadsecexp);

  SgValueExp * dimexp = new SgValueExp (dim+1);
  funcall->addArg(*dimexp);

  SgValueExp * amountexp = new SgValueExp (amount);
  funcall->addArg(*amountexp);

  s->insertStmtBefore(*funcall, *s->controlParent());
}

// add pcrc_communication_detection() call
void add_detect(SgStatement * s, int counter)
{
  int i;
  Forall_header_def * fhdef = (Forall_header_def *) s->attributeValue(0, FHDER_Def);
  SgStatement * body = s->childList1(0);
  forall_reference * lhsref = (forall_reference *)body->attributeValue(0, Forall_Ref);
  SgArrayRefExp *lhsarray = isSgArrayRefExp(lhsref->getexpression());
  SgSymbol *lhsarraysymb = lhsarray->symbol();

  forall_reference * rhsref = (forall_reference *)body->attributeValue(counter, Forall_Ref);
  SgArrayRefExp *rhsarray = isSgArrayRefExp(rhsref->getexpression());
  SgSymbol *rhsarraysymb = rhsarray->symbol();

  SgSymbol * symb=s->getSymbolInCurrentScope(mixstring, "communication_detection", NULL);
  SgFunctionCallExp * funcall= new SgFunctionCallExp(*symb);

  SgSymbol *lsymb=s->getSymbolInCurrentScope(mixstring, "dad", lhsarraysymb->identifier());
  SgVarRefExp * dadexp = new SgVarRefExp(lsymb);
  funcall->addArg(*dadexp);
  delete dadexp;

  SgSymbol *rsymb=s->getSymbolInCurrentScope(mixstring, "dad", rhsarraysymb->identifier());
  dadexp = new SgVarRefExp(rsymb);
  funcall->addArg(*dadexp);
  delete dadexp;

  SgExpression *dim = new SgValueExp(fhdef->getindexnumber());
  funcall->addArg(*dim);

  SgSymbol *a0symb=s->getSymbolInCurrentScope(mixstring, "a0", NULL,counter);
  SgSymbol *b0symb=s->getSymbolInCurrentScope(mixstring, "b0", NULL,counter);
  SgSymbol *c0symb=s->getSymbolInCurrentScope(mixstring, "c0", NULL,counter);
  SgSymbol *ind0symb=s->getSymbolInCurrentScope(mixstring, "ind0", NULL,counter);

  SgSymbol *a1symb=s->getSymbolInCurrentScope(mixstring, "a1", NULL,counter);
  SgSymbol *b1symb=s->getSymbolInCurrentScope(mixstring, "b1", NULL,counter);
  SgSymbol *c1symb=s->getSymbolInCurrentScope(mixstring, "c1", NULL,counter);
  SgSymbol *ind1symb=s->getSymbolInCurrentScope(mixstring, "ind1", NULL,counter);

  // assign lhs bound array: a0, b0, c0, ind0
  // a0:   lbound 
  // b0:   ubound
  // c0:   stride
  // ind0: forall index number
  for (i=0; i<lhsarray->numberOfSubscripts(); i++) {
	SgArrayRefExp *arrayExp1 = new SgArrayRefExp(*a0symb);
	SgArrayRefExp *arrayExp2 = new SgArrayRefExp(*b0symb);
	SgArrayRefExp *arrayExp3 = new SgArrayRefExp(*c0symb);
	SgArrayRefExp *arrayExp4 = new SgArrayRefExp(*ind0symb);
	SgExpression *sub = new SgValueExp(i+1);
	arrayExp1->addSubscript(*sub);
	arrayExp2->addSubscript(*sub);
	arrayExp3->addSubscript(*sub);
	arrayExp4->addSubscript(*sub);
	SgExpression *rhsExp1,*rhsExp2,*rhsExp3,*rhsExp4;
	if (lhsref->indexNumberOnDim(i) == -1)
	{
		rhsExp1 = lhsarray->subscript(i)->copyPtr();
		rhsExp2 = lhsarray->subscript(i)->copyPtr();
		rhsExp3 = new SgValueExp(1);
	}
	else
	{
		int indexDim = lhsref->indexNumberOnDim(i);
		SgExpression *lExp = fhdef->getindextriple(indexDim, 0)->copyPtr();
		SgExpression *uExp = fhdef->getindextriple(indexDim, 1)->copyPtr();
		SgExpression *sExp = fhdef->getindextriple(indexDim, 2);
		if (sExp == NULL) sExp = new SgValueExp(1);
		else sExp = sExp->copyPtr();
		SgExpression *aExp = lhsref->getstride(i,indexDim)->copyPtr();
		SgExpression *bExp = lhsref->getoffset(i,indexDim);
		if (bExp == NULL) bExp =  new SgValueExp(0);
		else bExp = bExp->copyPtr();
		rhsExp1 = calculateExp( &( *aExp * *lExp + *bExp ) );
		rhsExp2 = calculateExp( &( *aExp * *uExp + *bExp ) );
		rhsExp3 = calculateExp( &( *aExp * *sExp ) );
		analyse_expression(s, rhsExp1);
		analyse_expression(s, rhsExp2);
		analyse_expression(s, rhsExp3);
	}
	rhsExp4 = new SgValueExp(lhsref->indexNumberOnDim(i));
/*
	// collect expressions 
	collect_expression(s, rhsExp1, 0);
	collect_expression(s, rhsExp2, 0);
	collect_expression(s, rhsExp3, 0);
*/
	SgAssignStmt *assign1 = new SgAssignStmt(*arrayExp1,*rhsExp1);
  	s->insertStmtBefore(*assign1, *s->controlParent());
	SgAssignStmt *assign2 = new SgAssignStmt(*arrayExp2,*rhsExp2);
  	s->insertStmtBefore(*assign2, *s->controlParent());
	SgAssignStmt *assign3 = new SgAssignStmt(*arrayExp3,*rhsExp3);
  	s->insertStmtBefore(*assign3, *s->controlParent());
	SgAssignStmt *assign4 = new SgAssignStmt(*arrayExp4,*rhsExp4);
  	s->insertStmtBefore(*assign4, *s->controlParent());
  }
  {
  SgVarRefExp * exp1 = new SgVarRefExp(a0symb);
  funcall->addArg(*exp1);
  delete exp1;
  SgVarRefExp * exp2 = new SgVarRefExp(b0symb);
  funcall->addArg(*exp2);
  delete exp2;
  SgVarRefExp * exp3 = new SgVarRefExp(c0symb);
  funcall->addArg(*exp3);
  delete exp3;
  SgVarRefExp * exp4 = new SgVarRefExp(ind0symb);
  funcall->addArg(*exp4);
  delete exp4;
  }
  
  // rhs array
  for (i=0; i<rhsarray->numberOfSubscripts(); i++) {
	SgArrayRefExp *arrayExp1 = new SgArrayRefExp(*a1symb);
	SgArrayRefExp *arrayExp2 = new SgArrayRefExp(*b1symb);
	SgArrayRefExp *arrayExp3 = new SgArrayRefExp(*c1symb);
	SgArrayRefExp *arrayExp4 = new SgArrayRefExp(*ind1symb);
	SgExpression *sub = new SgValueExp(i+1);
	arrayExp1->addSubscript(*sub);
	arrayExp2->addSubscript(*sub);
	arrayExp3->addSubscript(*sub);
	arrayExp4->addSubscript(*sub);
	SgExpression *rhsExp1,*rhsExp2,*rhsExp3,*rhsExp4;
	if (rhsref->indexNumberOnDim(i) == -1)
	{
		rhsExp1 = rhsarray->subscript(i)->copyPtr();
		rhsExp2 = rhsarray->subscript(i)->copyPtr();
		rhsExp3 = new SgValueExp(1);
	}
	else
	{
		int indexDim = rhsref->indexNumberOnDim(i);
		SgExpression *lExp = fhdef->getindextriple(indexDim, 0)->copyPtr();
		SgExpression *uExp = fhdef->getindextriple(indexDim, 1)->copyPtr();
		SgExpression *sExp = fhdef->getindextriple(indexDim, 2);
		if (sExp == NULL) sExp = new SgValueExp(1);
		else sExp = sExp->copyPtr();
		SgExpression *aExp = rhsref->getstride(i,indexDim)->copyPtr();
		SgExpression *bExp = rhsref->getoffset(i,indexDim);
		if (bExp == NULL) bExp =  new SgValueExp(0);
		else bExp = bExp->copyPtr();
		rhsExp1 = calculateExp( &( *aExp * *lExp + *bExp ) );
		rhsExp2 = calculateExp( &( *aExp * *uExp + *bExp ) );
		rhsExp3 = calculateExp( &( *aExp * *sExp ) );
		analyse_expression(s, rhsExp1);
		analyse_expression(s, rhsExp2);
		analyse_expression(s, rhsExp3);
	}
	rhsExp4 = new SgValueExp(rhsref->indexNumberOnDim(i));
/*
	// collect expressions 
	collect_expression(s, rhsExp1, 0);
	collect_expression(s, rhsExp2, 0);
	collect_expression(s, rhsExp3, 0);
*/
	SgAssignStmt *assign1 = new SgAssignStmt(*arrayExp1,*rhsExp1);
  	s->insertStmtBefore(*assign1, *s->controlParent());
	SgAssignStmt *assign2 = new SgAssignStmt(*arrayExp2,*rhsExp2);
  	s->insertStmtBefore(*assign2, *s->controlParent());
	SgAssignStmt *assign3 = new SgAssignStmt(*arrayExp3,*rhsExp3);
  	s->insertStmtBefore(*assign3, *s->controlParent());
	SgAssignStmt *assign4 = new SgAssignStmt(*arrayExp4,*rhsExp4);
  	s->insertStmtBefore(*assign4, *s->controlParent());
  }
  {
  SgVarRefExp * exp1 = new SgVarRefExp(a1symb);
  funcall->addArg(*exp1);
  delete exp1;
  SgVarRefExp * exp2 = new SgVarRefExp(b1symb);
  funcall->addArg(*exp2);
  delete exp2;
  SgVarRefExp * exp3 = new SgVarRefExp(c1symb);
  funcall->addArg(*exp3);
  delete exp3;
  SgVarRefExp * exp4 = new SgVarRefExp(ind1symb);
  funcall->addArg(*exp4);
  delete exp4;
  }

  symb=s->getSymbolInCurrentScope(mixstring, "amount", NULL,counter);
  SgVarRefExp * exp = new SgVarRefExp(symb);
  funcall->addArg(*exp);
  delete exp;

  symb=s->getSymbolInCurrentScope(mixstring, "comm", NULL,counter);
  exp = new SgVarRefExp(symb);
  SgAssignStmt *assign = new SgAssignStmt(*exp,*funcall);
  s->insertStmtBefore(*assign, *s->controlParent());
/*
  // process expressions collected
  analyse_expression_list(s);
*/
}


/***************************************************************************
  	 main functions to deal with all kinds of communication types
	do_remap()
	do_gather()
	do_scatter()
	do_broadcast_scalar()
	do_broadcast_dim()
	do_detect()
***************************************************************************/

void do_i_write_halo(SgStatement * s, int counter)
{
  create_ishift_array(s, counter);
  define_ishift_shadow(s,counter);
  add_ishift_write_halo(s,counter);
}

void do_remap(SgStatement * s, int counter)
{
    // sdd
  create_section(s, counter);
    // tdd
  create_array(s, 0, counter);
  add_remap(s, counter);
}

void do_broadcast_scalar(SgStatement * s, int counter)
{
  create_section(s, counter);
  create_array(s, 1, counter);
  add_remap(s, counter);
}

void do_broadcast_dim(SgStatement * s, int counter)
{
  // create array section dad for the source array
  create_section(s, counter);
  // create array section dad for the destination
  create_array(s, 1, counter);
  add_remap(s, counter);
}

void do_gather(SgStatement *s, int counter)
{
  // create destination array, no need to create every dim, copy will do
  //create_array(s, 0, counter);
  create_gather_tdd(s,counter);
  // create temperary array to hold irregular subscripts
  create_subscripts(s,counter);
  // add gather 
  add_gather(s, counter);
  // delete temperate array and free stack
  delete_rhs_subscripts(s,counter);
}

// lhs section is created by create_lhs_section() , in trans_forall.cc
// only to lhs
void do_scatter(SgStatement *s, int counter)
{
  SgStatement * body = s->childList1(0);
  forall_reference *fref = (forall_reference *)body->attributeValue(0, Forall_Ref);

  SgArrayRefExp *irr_array = (SgArrayRefExp *)fref->getexpression()->attributeValue(0,IRREG_ARRAY);

  // we make things done reversely , because we insert new stmt after current statement.
  // delete subscript array , which is created by create_subscripts()
  delete_lhs_subscripts(s,0);
  add_scatter(s, 0);
  // create subscript arrays .
  create_subscripts (s , 0, irr_array);
}

void do_tshift(SgStatement * s, int counter, int * amount)
{
  create_section(s, counter);
  create_array(s, 1, counter);
  for (int i=0; i<MAX_ALIGN_DIM; i++) {
    // i shoud be the numbered according to section;
    // in fact, it should be processor dimention;

    if (*(amount+i)!=0) 
      add_shift(s, counter, i, *(amount+i));
  };
}

/***************************************************************************
		do_detect()
	runtime communication detection 
***************************************************************************/

// unknown mode
void compare_shadow_amount(SgStatement * s, int counter)
{
  SgStatement * body = s->childList1(0);
  forall_reference *fref = (forall_reference *)body->attributeValue(counter, Forall_Ref);
  SgArrayRefExp *array = isSgArrayRefExp(fref->getexpression()); ASSERT(array);
  SgSymbol *arraysymb = array->symbol();
  SgArrayType * arrayType=(SgArrayType *)arraysymb->type();

  SgSymbol *commsymb=s->getSymbolInCurrentScope(mixstring, "comshift", arraysymb->identifier());
  SgExpression *commExp = new SgVarRefExp(commsymb);
  int dim = arrayType->dimension();
  SgExpression *dimExp = new SgValueExp(dim);
  SgSymbol * indexsymb=s->getSymbolInCurrentScope(mixstring, "tmp","sdx");
  SgExpression *indexExp = new SgVarRefExp(indexsymb);

  SgSymbol * gtl=s->getSymbolInCurrentScope(mixstring, "gtl", arraysymb->identifier());
  SgArrayRefExp *gtlExp = new SgArrayRefExp(*gtl);
  SgSymbol * gtu=s->getSymbolInCurrentScope(mixstring, "gtu", arraysymb->identifier());
  SgArrayRefExp *gtuExp = new SgArrayRefExp(*gtu);
  gtlExp->addSubscript(*indexExp->copyPtr());
  gtuExp->addSubscript(*indexExp->copyPtr());

  SgSymbol * amount=s->getSymbolInCurrentScope(mixstring, "amount", NULL,counter);
  SgArrayRefExp *amountExp = new SgArrayRefExp(*amount);
  amountExp->addSubscript(*indexExp->copyPtr());
  SgExpression *amountExp1 = &( SgUMinusOp(*amountExp));
  SgExpression *conExp1 = &( *amountExp->copyPtr() < *new SgValueExp(0));
  SgExpression *conExp2 = &( *amountExp->copyPtr() > *new SgValueExp(0));

  SgExpression *commSet = commExp;

  SgAssignStmt *comm_not_set1 = new SgAssignStmt(*gtlExp, *amountExp1);
  SgSymbol * maxsymb=s->getSymbolInCurrentScope("max");
  SgFunctionRefExp * maxcall = new SgFunctionRefExp (*maxsymb);
  maxcall->addArg(*gtlExp->copyPtr());    
  maxcall->addArg(*amountExp1->copyPtr());    
  SgAssignStmt *comm_set1 = new SgAssignStmt(*gtlExp->copyPtr() , *maxcall);
  SgStatement *trueStmt = new SgIfStmt(*commSet, *comm_set1, *comm_not_set1);

  SgAssignStmt *comm_not_set0 = new SgAssignStmt(*gtuExp->copyPtr(), *amountExp->copyPtr());
  maxcall = new SgFunctionRefExp (*maxsymb);
  maxcall->addArg(*gtuExp->copyPtr());    
  maxcall->addArg(*amountExp->copyPtr());    
  SgAssignStmt *comm_set0 = new SgAssignStmt(*gtuExp->copyPtr() , *maxcall);
  SgStatement *falseStmt = new SgIfStmt(*commSet->copyPtr(), *comm_set0, *comm_not_set0);

  SgStatement *ifstmt = new SgIfStmt(*conExp2, *falseStmt);
  ifstmt = new SgIfStmt(*conExp1, *trueStmt, *ifstmt);
  SgStatement *dostmt = new SgForStmt(*indexsymb, *new SgValueExp(1), *dimExp, *ifstmt);
  s->insertStmtBefore(*dostmt, *s->controlParent());
}

// UNKNOW
void do_detect(SgStatement * s, int counter)
{
  SgStatement * body = s->childList1(0);
  forall_reference *fref = (forall_reference *)body->attributeValue(counter, Forall_Ref);
  SgSymbol *arraysymb = fref->getexpression()->symbol();

  forall_reference *lhsref = (forall_reference *)body->attributeValue(0, Forall_Ref);
  SgArrayRefExp *lhsarray = (SgArrayRefExp *)lhsref->getexpression();
  SgSymbol *lhsarraysymb = lhsarray->symbol();

  SgSymbol *stackBase=NULL;

  if (fref->sameAs != -1) {
  	stackBase = s->getSymbolInCurrentScope(mixstring, "stk", "sdx", fref->sameAs);
  	change_array_reference(s,counter,1,0,NULL,stackBase);
	return;
  }

  add_detect(s, counter);

  SgSymbol *csymb=s->getSymbolInCurrentScope(mixstring, "comm", NULL,counter);
  SgSymbol *ssymb=s->getSymbolInCurrentScope(mixstring, "comshift", arraysymb->identifier());

  int shift_ok = shift_is_ok(s,arraysymb);

  SgStatement *entry_loop, *entry_0, *entry_1;
  SgStatement *continueStmt2;
  SgLabel *label_loop;
  SgStatement *if_clean;

  // prepare branch entries
  {
    // goto NONE entry
  SgExpression *exp = new SgVarRefExp(csymb);
  SgExpression *conExp = &( SgEqOp(*exp,*new SgValueExp(0)));	// NONE
  entry_0 = new SgStatement(CONTINUE_NODE);
  SgLabel *label = new SgLabel(*entry_0);
  entry_0->setLabel(*label);
  SgStatement * gotoStmt = new SgGotoStmt(*label);  // goto none
  SgStatement *if_stmt = new SgLogIfStmt(*conExp, *gotoStmt);
  s->insertStmtBefore(*if_stmt, *s->controlParent());
    // goto SHIFT entry
  conExp = &( SgEqOp(*exp,*new SgValueExp(1)));	// SHIFT
  if (shift_ok)
  {
  entry_1 = new SgStatement(CONTINUE_NODE);
  label = new SgLabel(*entry_1);
  entry_1->setLabel(*label);
  gotoStmt = new SgGotoStmt(*label);
  if_stmt = new SgLogIfStmt(*conExp, *gotoStmt);  // goto shift
  s->insertStmtBefore(*if_stmt, *s->controlParent());
  }
  else {
	// treat shift as remap
  SgExpression *csymbExp = new SgVarRefExp(csymb);
  SgStatement *assign = new SgAssignStmt(*csymbExp, *new SgValueExp(2));
  if_stmt = new SgLogIfStmt(*conExp, *assign);
  s->insertStmtBefore(*if_stmt, *s->controlParent());
  }
    // do-loop entry
  entry_loop = new SgStatement(CONTINUE_NODE);
  label_loop = new SgLabel(*entry_loop);
  entry_loop->setLabel(*label_loop);
  }

  // clear temparory stack when remap
  {
  SgExpression *exp = new SgVarRefExp(csymb);
  SgExpression *conExp = &( SgNeqOp(*exp,*new SgValueExp(2)));// not remap
  continueStmt2 = new SgStatement(CONTINUE_NODE);
  SgLabel *label = new SgLabel(*continueStmt2);
  continueStmt2->setLabel(*label);
  SgStatement * gotoStmt = new SgGotoStmt(*label);
  if_clean = new SgLogIfStmt(*conExp, *gotoStmt);
  s->insertStmtAfter(*continueStmt2, *s->controlParent());
  }

  stackBase = s->getSymbolInCurrentScope(mixstring, "stk", "sdx", counter);

  // REMAP
  {
  do_remap(s, counter);
    //get the index , and modified it because this is remap.
  SgSymbol * tbs = s->getSymbolInCurrentScope(mixstring, "tbs", forall_level,counter);
  SgExpression *tbsExp = new SgVarRefExp(tbs);
  SgExpression *stackBaseExp = new SgVarRefExp(stackBase);
  SgStatement *indexstmt = new SgAssignStmt(*stackBaseExp, *tbsExp);
  s->insertStmtBefore(*indexstmt, *s->controlParent());
    //change_array_reference(s,counter,1,1,NULL,stackBase);
    // note: when lhs is out of core, we use sdd0 as pcrc_oc_write, which already add the v00 
    // as the offset, now sdx0 has been substracted with this offset.
  if (!is_out_of_core(lhsarraysymb))
     reset_array_base_for_reduced_array(s, counter, stackBase);
    // assign sdx? = sdx0 before body assign statement
  {
  SgSymbol * indexsym0 ;
  if (lhsarray->numberOfAttributes(SET_INCORE) > 0)
  	indexsym0 = s->getSymbolInCurrentScope(mixstring, "sdx", NULL,body->numberOfAttributes(Forall_Ref)); 
  else
  	indexsym0 = s->getSymbolInCurrentScope(mixstring, "sdx", NULL,0); 
  SgExpression *indexsym0Exp = new SgVarRefExp(indexsym0);
  SgSymbol * indexsym1 = s->getSymbolInCurrentScope(mixstring, "sdx", NULL,counter); 
  SgExpression *indexsym1Exp = new SgVarRefExp(indexsym1);
  SgAssignStmt *assignstmt = new SgAssignStmt(*indexsym1Exp, *indexsym0Exp);
  SgExpression *exp = new SgVarRefExp(csymb);
  SgExpression *conExp = &( SgEqOp(*exp,*new SgValueExp(2)));
  SgStatement *add_stmt = new SgLogIfStmt(*conExp->copyPtr(), *assignstmt);
    // if lhs and rhs are all outofcore, insert this statement among the tiling loops.
  if (is_out_of_core(arraysymb) && is_out_of_core(lhsarraysymb) ) 
  	body->addAttribute(INDEX_SDX, add_stmt , sizeof(add_stmt) );
  else
	body->insertStmtAfter(*add_stmt, *body->controlParent());      // insert after , later it will be collected.
  }
    // jump cross SHIFT/NONE branch
  SgStatement * gotoStmt = new SgGotoStmt(*label_loop);
  s->insertStmtBefore(*gotoStmt, *s->controlParent());
  }

  // SHIFT
  if (shift_ok)
  {
  s->insertStmtBefore(*entry_1, *s->controlParent());
  if (fref->isIShift()) {
    do_i_write_halo(s, counter);
  }
  else
  {
  // compare gtl & gtu
  compare_shadow_amount(s,counter);
  // set 1
  SgExpression *lhs = new SgVarRefExp(ssymb);
  SgStatement *stmt = new SgAssignStmt(*lhs, *new SgBoolValueExp(1));
  s->insertStmtBefore(*stmt, *s->controlParent());
  }
  }

  // NONE
  {
  s->insertStmtBefore(*entry_0, *s->controlParent());
  SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
  SgStatement *indexstmt=make_index(s,stackBase,dad,arraysymb->type());
  s->insertStmtBefore(*indexstmt, *s->controlParent());
    // for OUT_OF_CORE
  if (is_out_of_core(arraysymb)) {
      	SgSymbol * tdddad = s->getSymbolInCurrentScope(mixstring, "tdd", forall_level,counter);
	SgStatement *assign = new SgAssignStmt(*new SgVarRefExp(tdddad), *new SgVarRefExp(dad));
  	s->insertStmtBefore(*assign, *s->controlParent());
  }
  add_coef(s, counter,NULL);
  append_index(s, counter,2);  //   unknown detection
  }

  change_array_reference(s,counter,1,0,NULL,stackBase);

  {
  s->insertStmtBefore(*entry_loop, *s->controlParent());
  s->insertStmtAfter(*if_clean, *s->controlParent());
  }
}


